/***************************************************************************
    COPYRIGHT NOTE

    DAMNICK:		DAta Moving through a NIC connected in loopbacK
			NIC-independent macros.

    Copyright		(C) 2001 Giuseppe Ciaccio
    Institution:	DISI, Universita' di Genova
    Address:		via Dodecaneso 35, I-16146 Genova, Italy
    e-mail:		ciaccio@disi.unige.it

    This program  or include  file  is free software,  either  original  or
    derived from other  software made available  under the terms of the GNU
    General Public License. You can redistribute and/or modify this program
    or include  file under the  terms of the GNU  General Public License as
    published  by the  Free Software Foundation;  either version 2  of  the
    License, or (at your option) any later version.

    THIS  SOFTWARE  IS PROVIDED   ``AS  IS'' AND   ANY  EXPRESS OR   IMPLIED
    WARRANTIES,   INCLUDING, BUT NOT  LIMITED  TO, THE IMPLIED WARRANTIES OF
    MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  IN
    NO  EVENT  SHALL   THE AUTHOR  BE    LIABLE FOR ANY   DIRECT,  INDIRECT,
    INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
    NOT LIMITED   TO, PROCUREMENT OF  SUBSTITUTE GOODS  OR SERVICES; LOSS OF
    USE, DATA,  OR PROFITS; OR  BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
    ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR TORT
    (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
    THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

    You should have received a copy of the  GNU General Public License along
    with this program; if not, write  to the Free Software Foundation, Inc.,
    675 Mass Ave, Cambridge, MA 02139, USA.

    END OF COPYRIGHT NOTE
****************************************************************************/

#define lmin(a,b) ((a)<=(b)?(a):(b))
#define lmax(a,b) ((a)>=(b)?(a):(b))

#define gamma_time(a) damnick_time(a)
#define gamma_time_diff_ticks(a,b) damnick_time_diff_ticks(a,b)


#ifdef DRIVER_DEBUG
#define DEBUG(a) {a;}
#define DEBUG_L(a) {a;}
#else
#ifdef DRIVER_DEBUG_LIGHT
#define DEBUG(a)
#define DEBUG_L(a) {a;}
#else
#define DEBUG(a)
#define DEBUG_L(a)
#endif
#endif


#define user_space_to_phys(P,addr) \
(unsigned long)virt_to_bus( \
	(void *)( \
		(unsigned long)pte_page( \
			*pte_offset( \
				pmd_offset( \
					pgd_offset( \
						(P)->mm, \
						(unsigned long)(addr) \
					), \
					(unsigned long)(addr) \
				), \
				(unsigned long)(addr) \
			) \
		)->virtual \
		| ((unsigned long)(addr) & 0x00000fff) \
	) \
)


#define busywait(n) \
{ \
	time_586 a,b; \
	gamma_time(a); \
	for (;;) { \
		gamma_time(b); \
		if ( \
gamma_time_diff_ticks(b,a) > (unsigned long long)(n)*CLOCK \
		) \
			break; \
	} \
}


#define tx_ring_has_room() (tx_ring_occupancy < DAMNICK_TX_RING_SIZE-30)


#define tx_ring_is_full() (tx_ring_occupancy >= DAMNICK_TX_RING_SIZE-10)


#define IRQ_enable_for_5usec(t_elaps,t_start) \
if ( \
damnick_time_diff_ticks((t_elaps),(t_start)) > (unsigned long long)9000*CLOCK \
) { \
/* \
 *  Open a 5 usec window for IRQs every 9 msec, necessary for \
 *  the correct management of the OS clock (gettimeoday()). \
 */ \
 save_flags(flags); \
 sti(); \
 busywait(5); \
 restore_flags(flags); \
 damnick_time(t_start); \
}
