/***************************************************************************
	Read COPYRIGHT file in this directory
****************************************************************************/


typedef union {
	unsigned long ll;
	unsigned short ss[2];
} l2s;

typedef struct {
	unsigned short partner_instnum;
	unsigned short partner_port;
	unsigned char partner_par_pid;
	unsigned char partner_procnum;
	unsigned short phys_partner_node;
	unsigned char handler_has_run;
	unsigned char has_rec_handler;
	unsigned char buffer_kind;
	unsigned char boundary_1p;
	unsigned short semaphore;
	unsigned char dummy1; /* alignment */
	unsigned char dummy2; /* alignment */
	void *in_buffer;
	unsigned long in_size;
	void *in_progress;
	unsigned long in_room;

/*  Added this to support Lars' GAMMA sockets in multithreaded programs  */
	struct task_struct *task;	/* the process or thread who uses this port for input */
#ifdef MORE_INSTANCES_ON_SAME_NODE
	unsigned char partner_is_same_node;
	unsigned char bcast_was_susp;
	unsigned short dummy4; /* alignment */
#endif
	int suspended_isend_handle;  /*  Signed:  Default value is < 0  */
	void *current_tx_data1;
	unsigned long current_tx_len1;
	void *current_tx_data2;
	unsigned long current_tx_len2;
	unsigned long current_rx_msglen;
	l2s *header;
		/*
		 *  Header for frames, plus room for a possible payload
		 *  (first packet only).	
		 */
} port_entry;

typedef struct {
	port_entry port_table[MAX_PORT_NUMBER+1];

	/*
	 *  Pointers to user-space dispatchers
	 *  for rec/err handlers and atomic functions.
	 */
	void *handler_rec_dispatcher;
	void *handler_err_dispatcher;
	void *handler_atomic_dispatcher;

	/*
	 *  Pointers to user-space tables of semaphores
	 *  for recv and err notifications.
	 */
	void *sem1_table;
#ifdef USE_DAMNICK
	void *pre_sem_table;
#endif
	void *semerr_table;

	int pid;
/*
 *  The following is also present in the "port_entry" data struct,
 *  to allow multiple threads: different threads can use different
 *  input ports.  In that case, however, the "pid" is unneeded.
 */
	struct task_struct *task;
	int whoami;
		/*
		 *  "whoami" wrt the virtual GAMMA corresponding to this entry
		 *  Not unsigned because -1 ==
		 *  "not belonging to this virtual GAMMA"
		 */
	int has_pkts_in_rx_tmp_ring;
#ifdef USE_DAMNICK
	unsigned int pad_to_cacheline[6];
#else
	unsigned int pad_to_cacheline[7];
#endif
} instance_entry;

typedef struct {
	unsigned long how_many_nodes;
	unsigned char node_list[MAX_NUM_NODES];
	char wish_flag[MAX_NUM_NODES];  /*  The sign is important here!  */
} vm_descriptor;

typedef struct {
	unsigned long num_locinst;
		/*  How many proc instances of this group run on this node?  */
	instance_entry inst_table[MAX_NUM_LOCAL_INST];
	vm_descriptor vm;
	eth_addr eth_table[MAX_NUM_NODES];
} par_entry;
